-- | Stolen from rack-contrib: Bounce those annoying favicon.ico requests
module Hack.Contrib.Middleware.BounceFavicon (bounce_favicon) where

import Hack
import Hack.Contrib.Utils
import Hack.Contrib.Middleware.NotFound

import MPSUTF8
import Prelude hiding ((.), (^), (>), head)


bounce_favicon :: Middleware
bounce_favicon app = \env -> do
  if env.path_info.is "/favicon.ico"
    then not_found dummy_app env
    else app env
