module Hack.Contrib.Middleware.Head (head) where

import Hack
import Hack.Contrib.Response

import MPSUTF8
import Prelude hiding ((.), (^), (>), head)

head :: Middleware
head app = \env -> do
  response <- app env
  if env.request_method.is HEAD 
    then response .set_body "" .set_content_length 0 .return
    else response .return
